#include "hmg.ch"

proc main
	**********
	SET OOP ON
	**********
	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 640 HEIGHT 480 ;
		TITLE 'Test';
		MAIN

		DEFINE SPLITBOX
		DEFINE TOOLBAR ToolBar_1 CAPTION ""              BUTTONSIZE 102,32 FLAT
			BUTTON 01  CAPTION 'Open Window 2'  ACTION wPost()  SEPARATOR
			BUTTON 02  CAPTION 'Open Window 3'  ACTION wPost()
		END TOOLBAR
		
		DEFINE TOOLBAR ToolBar_2 CAPTION ""              BUTTONSIZE 42,32 FLAT
			BUTTON 99  CAPTION 'Exit'         ACTION wPost() 
		END TOOLBAR
		END SPLITBOX

		WITH OBJECT This.Object                           // ---- Window events
			// ToolBar 1
			:Event( 01, {|ow| DoWindow2(ow) } )
			:Event( 02, {|ow| DoWindow3(ow) } )
			// ToolBar 2
			:Event( 99, {|ow| ow:Release()      } )
		END WITH                                          // ---- Window events

	END WINDOW

	activate window Form_1
retu

//*****************************************************************************
func DoWindow2( oParent )
	*********************
	oParent:Action := .F.     // Lock work message parent window
	*********************
	DEFINE WINDOW Form_2 ;
		AT 0,0 ;
		WIDTH 600 HEIGHT 400 ;
		TITLE 'Win 2' ;
		CHILD ;
		ON RELEASE wSend(98)

		@ 50,100 BUTTON Button_2 caption 'OK' WIDTH 100 HEIGHT 20 ACTION {|| MsgBox('OK') }

      WITH OBJECT This.Object                           // ---- Window events
      :Event( 98, {|| oParent:Action := .T. } ) // UnLock work message parent window
      :Event( 99, {|ow| ow:Release() } )
      END WITH                                          // ---- Window events

      ON KEY ESCAPE ACTION wPost(99)

	END WINDOW

	activate window Form_2
return

//*****************************************************************************
func DoWindow3( oParent )
	*********************
	oParent:Action := .F.     // Lock work message parent window
	*********************
	DEFINE WINDOW Form_3 ;
		AT 0,0 ;
		WIDTH 600 HEIGHT 400 ;
		TITLE 'Win 3';
		CHILD ;
		ON RELEASE wSend(98)

		@ 50,100 BUTTON Button_2 caption 'OK' WIDTH 100 HEIGHT 20 ACTION {|| MsgBox('OK') }

      WITH OBJECT This.Object                           // ---- Window events
      :Event( 98, {|| oParent:Action := .T. } ) // UnLock work message parent window
      :Event( 99, {|ow| ow:Release() } )
      END WITH                                          // ---- Window events

      ON KEY ESCAPE ACTION wPost(99)

	END WINDOW

	activate window Form_3
return

*----------------------------------------------------------------------------*
FUNC wPost( nEvent, nIndex, xParam )
*----------------------------------------------------------------------------*
   LOCAL oWnd

   IF HB_ISOBJECT( nIndex )

      IF nIndex:ClassName == 'TSBROWSE'
         oWnd := _WindowObj( nIndex:cParentWnd )
      ELSE
         oWnd := nIndex
      ENDIF

      oWnd:SetProp( nEvent, xParam )
      oWnd:PostMsg( nEvent )

   ELSE

      DEFAULT nEvent := Val( This.Name )

      IF nEvent > 0
         oWnd := ThisWindow.Object
         oWnd:SetProp( nEvent, xParam )
         oWnd:PostMsg( nEvent, nIndex )
      ENDIF

   ENDIF

RETURN NIL

*----------------------------------------------------------------------------*
FUNC wSend( nEvent, nIndex, xParam )
*----------------------------------------------------------------------------*
   LOCAL oWnd

   IF HB_ISOBJECT( nIndex )

      IF nIndex:ClassName == 'TSBROWSE'
         oWnd := _WindowObj( nIndex:cParentWnd )
      ELSE
         oWnd := nIndex
      ENDIF

      oWnd:SetProp( nEvent, xParam )
      oWnd:SendMsg( nEvent )

   ELSE

      DEFAULT nEvent := Val( This.Name )

      IF nEvent > 0
         oWnd := ThisWindow.Object
         oWnd:SetProp( nEvent, xParam )
         oWnd:SendMsg( nEvent, nIndex )
      ENDIF

   ENDIF

RETURN NIL
